<?php
/**
 * Carerix PHP Library
 *
 * LICENSE
 *
 * This source file is subject to the LGPL license that is 
 * available through the world-wide-web at this URL:
 * http://www.opensource.org/licenses/lgpl-license.php
 *
 * @category Carerix
 * @author Andrey Yakubovskiy <andrey.yakubovskiy@gmail.com>
 * @copyright Copyright (c) 2013 Carerix.com (http://www.carerix.com)
 * @license http://www.opensource.org/licenses/lgpl-license.php  LGPL
 * @link http://www.carerix.com
 * @version 2013-03-06 12:51:46Z
 */
 
/**
 * @note THIS FILE WAS GENERATED AUTOMATICALLY. DO NOT MODIFY IT. YOUR CHANGES WILL
 * BE LOST. INSTEAD MODIFY CONCRETE IMPLEMENTATION OF THIS CLASS.
 * @category Carerix
 * @licence http://www.opensource.org/licenses/lgpl-license.php LGPL
 * @link http://www.carerix.com
 * @copyright Copyright 2011-2012 Carerix (http://www.carerix.com). All rights
 * reserved.
 * @author Andrey Yakubovskiy <andrey.yakubovskiy@gmail.com>
 * @version Thu, 06 Dec 2012 08:56:02 +0000
 */
abstract class Carerix_Api_Rest_Entity_Abstract_CRMedium extends Carerix_Api_Rest_Entity
{

    /**
     * @access private
     * @var integer
     * @value_class NSNumber
     * @allows_null 0
     * @value_type i
     * @value_type_human long integer (32 bits)
     */
    public $mediumID = null;

    /**
     * @access private
     * @var string
     * @value_class NSCalendarDate
     * @allows_null 1
     */
    public $creationDate = null;

    /**
     * @access private
     * @var integer
     * @value_class NSNumber
     * @allows_null 1
     * @value_type i
     * @value_type_human long integer (32 bits)
     */
    public $status = null;

    /**
     * @access private
     * @var string
     * @value_class NSCalendarDate
     * @allows_null 1
     */
    public $modificationDate = null;

    /**
     * @access private
     * @var integer
     * @value_class NSNumber
     * @allows_null 0
     * @value_type s
     * @value_type_human short integer (16 bits)
     */
    public $active = null;

    /**
     * @access private
     * @var string
     * @value_class NSString
     * @allows_null 0
     * @width 64
     */
    public $name = null;

    /**
     * @access private
     * @var integer
     * @value_class NSNumber
     * @allows_null 1
     * @value_type i
     * @value_type_human long integer (32 bits)
     */
    public $mediumTypeKey = null;

    /**
     * @access private
     * @var string
     * @value_class NSString
     * @allows_null 1
     * @width 1000000
     */
    public $notes = null;

    /**
     * @access private
     * @var string
     * @value_class NSString
     * @allows_null 1
     * @width 1000000
     */
    public $costs = null;

    /**
     * @access private
     * @var integer
     * @value_class NSNumber
     * @allows_null 0
     * @value_type s
     * @value_type_human short integer (16 bits)
     */
    public $autoPublish = null;

    /**
     * @access private
     * @var integer
     * @value_class NSNumber
     * @allows_null 0
     * @value_type s
     * @value_type_human short integer (16 bits)
     */
    public $isHTML = null;

    /**
     * @access private
     * @var string
     * @value_class NSString
     * @allows_null 1
     * @width 80
     */
    public $subscription = null;

    /**
     * @access private
     * @var string
     * @value_class NSCalendarDate
     * @allows_null 1
     */
    public $validUntil = null;

    /**
     * @access private
     * @var string
     * @value_class NSString
     * @allows_null 1
     * @width 15
     */
    public $agencyNo = null;

    /**
     * @access private
     * @var string
     * @value_class NSString
     * @allows_null 1
     * @width 255
     */
    public $code = null;

    /**
     * @access private
     * @var string
     * @value_class NSString
     * @allows_null 1
     * @width 16
     * @isUnique 1
     */
    public $importID = null;

    /**
     * @access private
     * @var string
     * @value_class NSString
     * @allows_null 1
     * @width 60
     */
    public $languages = null;

    /**
     * @access private
     * @var integer
     * @value_class NSNumber
     * @allows_null 1
     * @value_type i
     * @value_type_human long integer (32 bits)
     */
    public $credits = null;

    /**
     * @access private
     * @var integer
     * @value_class NSNumber
     * @allows_null 0
     * @value_type s
     * @value_type_human short integer (16 bits)
     */
    public $isDefault = null;

    /**
     * @access private
     * @var integer
     * @value_class NSNumber
     * @allows_null 1
     * @value_type i
     * @value_type_human long integer (32 bits)
     */
    public $expireTime = null;

    /**
     * @access private
     * @var string
     * @value_class NSString
     * @allows_null 1
     * @width 1000000
     */
    public $parserFromAddress = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_DataType_NSDictionary|array
     * @value_class NSDictionary
     * @allows_null 1
     */
    public $jobBoardInfo = null;

    /**
     * @access private
     * @var integer
     * @value_class NSNumber
     * @allows_null 0
     * @value_type s
     * @value_type_human short integer (16 bits)
     */
    public $isSystem = null;

    /**
     * @access private
     * @var string
     * @value_class NSString
     * @allows_null 1
     * @width 100
     */
    public $parserSubjectCode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRUser
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRUser")
     * @mandatory 0
     * @destination_entity CRUser
     * @to_many 0
     * @name modifiedBy
     */
    public $modifiedBy = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRUser
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRUser")
     * @mandatory 0
     * @destination_entity CRUser
     * @to_many 0
     * @name owner
     */
    public $owner = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRUser
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRUser")
     * @mandatory 0
     * @destination_entity CRUser
     * @to_many 0
     * @name createdBy
     */
    public $createdBy = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CREmailTemplate
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CREmailTemplate")
     * @mandatory 0
     * @destination_entity CREmailTemplate
     * @to_many 0
     * @name toEmailTemplate
     */
    public $toEmailTemplate = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRStatusInfo
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRStatusInfo")
     * @mandatory 0
     * @destination_entity CRStatusInfo
     * @to_many 0
     * @name defaultStatusInfo
     */
    public $defaultStatusInfo = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRTemplateReference
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRTemplateReference")
     * @mandatory 0
     * @destination_entity CRTemplateReference
     * @to_many 0
     * @name toTemplateReference
     */
    public $toTemplateReference = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRMedium
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRMedium")
     * @mandatory 0
     * @destination_entity CRMedium
     * @to_many 0
     * @name toParentMedium
     */
    public $toParentMedium = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_CRMedium")
     * @mandatory 0
     * @destination_entity CRMedium
     * @to_many 1
     * @name children
     */
    public $children = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRDataNode
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRDataNode")
     * @mandatory 0
     * @destination_entity CRDataNode
     * @to_many 0
     * @name toExpireUnitNode
     * @qualifier ((typeID = 117) or (typeID = 0))
     * @default
     * @nodeType Verlooptijd-eenheid
     */
    public $toExpireUnitNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRDataNode
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRDataNode")
     * @mandatory 0
     * @destination_entity CRDataNode
     * @to_many 0
     * @name toSourceMatchNode
     * @qualifier ((typeID = 88) or (typeID = 0))
     * @default
     * @nodeType Bron-Match
     */
    public $toSourceMatchNode = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRDataNode
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRDataNode")
     * @mandatory 0
     * @destination_entity CRDataNode
     * @to_many 0
     * @name toParserTypeNode
     */
    public $toParserTypeNode = null;

    public static function configure(Carerix_Api_Rest_EntityConfiguration $entityConfiguration)
    {
        parent::configure($entityConfiguration);
        $entityConfiguration->setIdentifierKey("mediumID");
        $entityConfiguration->setName("CRMedium");
    }

    /**
     * Set mediumID.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRMedium
     */
    public function setMediumID($value)
    {
        $this->mediumID = $value;
        return $this;
    }

    /**
     * Get mediumID.
     *
     * @return integer
     */
    public function getMediumID()
    {
        return $this->mediumID;
    }

    /**
     * Set creationDate.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRMedium
     */
    public function setCreationDate($value)
    {
        $this->creationDate = $value;
        return $this;
    }

    /**
     * Get creationDate.
     *
     * @return string
     */
    public function getCreationDate()
    {
        return $this->creationDate;
    }

    /**
     * Set status.
     *
     * Provides a fluent interface.
     *
     * @param integer $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRMedium
     */
    public function setStatus($value)
    {
        $this->status = $value;
        return $this;
    }

    /**
     * Get status.
     *
     * @return integer
     */
    public function getStatus()
    {
        return $this->status;
    }

    /**
     * Set modificationDate.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRMedium
     */
    public function setModificationDate($value)
    {
        $this->modificationDate = $value;
        return $this;
    }

    /**
     * Get modificationDate.
     *
     * @return string
     */
    public function getModificationDate()
    {
        return $this->modificationDate;
    }

    /**
     * Set active.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRMedium
     */
    public function setActive($value)
    {
        $this->active = $value;
        return $this;
    }

    /**
     * Get active.
     *
     * @return integer
     */
    public function getActive()
    {
        return $this->active;
    }

    /**
     * Set name.
     *
     * Provides a fluent interface.
     *
     * @param string $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRMedium
     */
    public function setName($value)
    {
        $this->name = $value;
        return $this;
    }

    /**
     * Get name.
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Set mediumTypeKey.
     *
     * Provides a fluent interface.
     *
     * @param integer $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRMedium
     */
    public function setMediumTypeKey($value)
    {
        $this->mediumTypeKey = $value;
        return $this;
    }

    /**
     * Get mediumTypeKey.
     *
     * @return integer
     */
    public function getMediumTypeKey()
    {
        return $this->mediumTypeKey;
    }

    /**
     * Set notes.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRMedium
     */
    public function setNotes($value)
    {
        $this->notes = $value;
        return $this;
    }

    /**
     * Get notes.
     *
     * @return string
     */
    public function getNotes()
    {
        return $this->notes;
    }

    /**
     * Set costs.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRMedium
     */
    public function setCosts($value)
    {
        $this->costs = $value;
        return $this;
    }

    /**
     * Get costs.
     *
     * @return string
     */
    public function getCosts()
    {
        return $this->costs;
    }

    /**
     * Set autoPublish.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRMedium
     */
    public function setAutoPublish($value)
    {
        $this->autoPublish = $value;
        return $this;
    }

    /**
     * Get autoPublish.
     *
     * @return integer
     */
    public function getAutoPublish()
    {
        return $this->autoPublish;
    }

    /**
     * Set isHTML.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRMedium
     */
    public function setIsHTML($value)
    {
        $this->isHTML = $value;
        return $this;
    }

    /**
     * Get isHTML.
     *
     * @return integer
     */
    public function getIsHTML()
    {
        return $this->isHTML;
    }

    /**
     * Set subscription.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRMedium
     */
    public function setSubscription($value)
    {
        $this->subscription = $value;
        return $this;
    }

    /**
     * Get subscription.
     *
     * @return string
     */
    public function getSubscription()
    {
        return $this->subscription;
    }

    /**
     * Set validUntil.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRMedium
     */
    public function setValidUntil($value)
    {
        $this->validUntil = $value;
        return $this;
    }

    /**
     * Get validUntil.
     *
     * @return string
     */
    public function getValidUntil()
    {
        return $this->validUntil;
    }

    /**
     * Set agencyNo.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRMedium
     */
    public function setAgencyNo($value)
    {
        $this->agencyNo = $value;
        return $this;
    }

    /**
     * Get agencyNo.
     *
     * @return string
     */
    public function getAgencyNo()
    {
        return $this->agencyNo;
    }

    /**
     * Set code.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRMedium
     */
    public function setCode($value)
    {
        $this->code = $value;
        return $this;
    }

    /**
     * Get code.
     *
     * @return string
     */
    public function getCode()
    {
        return $this->code;
    }

    /**
     * Set importID.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRMedium
     */
    public function setImportID($value)
    {
        $this->importID = $value;
        return $this;
    }

    /**
     * Get importID.
     *
     * @return string
     */
    public function getImportID()
    {
        return $this->importID;
    }

    /**
     * Set languages.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRMedium
     */
    public function setLanguages($value)
    {
        $this->languages = $value;
        return $this;
    }

    /**
     * Get languages.
     *
     * @return string
     */
    public function getLanguages()
    {
        return $this->languages;
    }

    /**
     * Set credits.
     *
     * Provides a fluent interface.
     *
     * @param integer $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRMedium
     */
    public function setCredits($value)
    {
        $this->credits = $value;
        return $this;
    }

    /**
     * Get credits.
     *
     * @return integer
     */
    public function getCredits()
    {
        return $this->credits;
    }

    /**
     * Set isDefault.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRMedium
     */
    public function setIsDefault($value)
    {
        $this->isDefault = $value;
        return $this;
    }

    /**
     * Get isDefault.
     *
     * @return integer
     */
    public function getIsDefault()
    {
        return $this->isDefault;
    }

    /**
     * Set expireTime.
     *
     * Provides a fluent interface.
     *
     * @param integer $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRMedium
     */
    public function setExpireTime($value)
    {
        $this->expireTime = $value;
        return $this;
    }

    /**
     * Get expireTime.
     *
     * @return integer
     */
    public function getExpireTime()
    {
        return $this->expireTime;
    }

    /**
     * Set parserFromAddress.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRMedium
     */
    public function setParserFromAddress($value)
    {
        $this->parserFromAddress = $value;
        return $this;
    }

    /**
     * Get parserFromAddress.
     *
     * @return string
     */
    public function getParserFromAddress()
    {
        return $this->parserFromAddress;
    }

    /**
     * Set jobBoardInfo.
     *
     * Provides a fluent interface.
     *
     * @param Carerix_Api_Rest_DataType_NSDictionary|array $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRMedium
     */
    public function setJobBoardInfo($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_DataType_NSDictionary($value);
        }
        $this->jobBoardInfo = $value;
        return $this;
    }

    /**
     * Get jobBoardInfo.
     *
     * @return Carerix_Api_Rest_DataType_NSDictionary|array
     */
    public function getJobBoardInfo()
    {
        return $this->jobBoardInfo;
    }

    /**
     * Set isSystem.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRMedium
     */
    public function setIsSystem($value)
    {
        $this->isSystem = $value;
        return $this;
    }

    /**
     * Get isSystem.
     *
     * @return integer
     */
    public function getIsSystem()
    {
        return $this->isSystem;
    }

    /**
     * Set parserSubjectCode.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRMedium
     */
    public function setParserSubjectCode($value)
    {
        $this->parserSubjectCode = $value;
        return $this;
    }

    /**
     * Get parserSubjectCode.
     *
     * @return string
     */
    public function getParserSubjectCode()
    {
        return $this->parserSubjectCode;
    }

    /**
     * Set modifiedBy.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRUser $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRMedium
     */
    public function setModifiedBy($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRUser($value); 
        }                 
        $this->modifiedBy = $value;
        return $this;
    }

    /**
     * Get modifiedBy.
     *
     * @return Carerix_Api_Rest_Entity_CRUser
     */
    public function getModifiedBy()
    {
        return $this->modifiedBy;
    }

    /**
     * Set owner.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRUser $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRMedium
     */
    public function setOwner($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRUser($value); 
        }                 
        $this->owner = $value;
        return $this;
    }

    /**
     * Get owner.
     *
     * @return Carerix_Api_Rest_Entity_CRUser
     */
    public function getOwner()
    {
        return $this->owner;
    }

    /**
     * Set createdBy.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRUser $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRMedium
     */
    public function setCreatedBy($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRUser($value); 
        }                 
        $this->createdBy = $value;
        return $this;
    }

    /**
     * Get createdBy.
     *
     * @return Carerix_Api_Rest_Entity_CRUser
     */
    public function getCreatedBy()
    {
        return $this->createdBy;
    }

    /**
     * Set toEmailTemplate.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CREmailTemplate $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRMedium
     */
    public function setToEmailTemplate($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CREmailTemplate($value); 
        }                 
        $this->toEmailTemplate = $value;
        return $this;
    }

    /**
     * Get toEmailTemplate.
     *
     * @return Carerix_Api_Rest_Entity_CREmailTemplate
     */
    public function getToEmailTemplate()
    {
        return $this->toEmailTemplate;
    }

    /**
     * Set defaultStatusInfo.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRStatusInfo $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRMedium
     */
    public function setDefaultStatusInfo($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRStatusInfo($value); 
        }                 
        $this->defaultStatusInfo = $value;
        return $this;
    }

    /**
     * Get defaultStatusInfo.
     *
     * @return Carerix_Api_Rest_Entity_CRStatusInfo
     */
    public function getDefaultStatusInfo()
    {
        return $this->defaultStatusInfo;
    }

    /**
     * Set toTemplateReference.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRTemplateReference $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRMedium
     */
    public function setToTemplateReference($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRTemplateReference($value); 
        }                 
        $this->toTemplateReference = $value;
        return $this;
    }

    /**
     * Get toTemplateReference.
     *
     * @return Carerix_Api_Rest_Entity_CRTemplateReference
     */
    public function getToTemplateReference()
    {
        return $this->toTemplateReference;
    }

    /**
     * Set toParentMedium.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRMedium $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRMedium
     */
    public function setToParentMedium($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRMedium($value); 
        }                 
        $this->toParentMedium = $value;
        return $this;
    }

    /**
     * Get toParentMedium.
     *
     * @return Carerix_Api_Rest_Entity_CRMedium
     */
    public function getToParentMedium()
    {
        return $this->toParentMedium;
    }

    /**
     * Set children.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_CRMedium
     */
    public function setChildren($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values, 'Carerix_Api_Rest_Entity_CRMedium'); 
        } 
        $this->children = $values;
        return $this;
    }

    /**
     * Get children.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_CRMedium
     */
    public function getChildren($index = null)
    {
        if($index !== null) {
            return $this->children[$index];
        }
        return $this->children;
    }

    /**
     * Set toExpireUnitNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRDataNode $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRMedium
     */
    public function setToExpireUnitNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRDataNode($value); 
        }                 
        $this->toExpireUnitNode = $value;
        return $this;
    }

    /**
     * Get toExpireUnitNode.
     *
     * @return Carerix_Api_Rest_Entity_CRDataNode
     */
    public function getToExpireUnitNode()
    {
        return $this->toExpireUnitNode;
    }

    /**
     * Set toSourceMatchNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRDataNode $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRMedium
     */
    public function setToSourceMatchNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRDataNode($value); 
        }                 
        $this->toSourceMatchNode = $value;
        return $this;
    }

    /**
     * Get toSourceMatchNode.
     *
     * @return Carerix_Api_Rest_Entity_CRDataNode
     */
    public function getToSourceMatchNode()
    {
        return $this->toSourceMatchNode;
    }

    /**
     * Set toParserTypeNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRDataNode $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRMedium
     */
    public function setToParserTypeNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRDataNode($value); 
        }                 
        $this->toParserTypeNode = $value;
        return $this;
    }

    /**
     * Get toParserTypeNode.
     *
     * @return Carerix_Api_Rest_Entity_CRDataNode
     */
    public function getToParserTypeNode()
    {
        return $this->toParserTypeNode;
    }


}