<?php
/**
 * Carerix PHP Library
 *
 * LICENSE
 *
 * This source file is subject to the LGPL license that is 
 * available through the world-wide-web at this URL:
 * http://www.opensource.org/licenses/lgpl-license.php
 *
 * @category Carerix
 * @author Andrey Yakubovskiy <andrey.yakubovskiy@gmail.com>
 * @copyright Copyright (c) 2013 Carerix.com (http://www.carerix.com)
 * @license http://www.opensource.org/licenses/lgpl-license.php  LGPL
 * @link http://www.carerix.com
 * @version 2013-03-06 12:51:46Z
 */
 
/**
 * @note THIS FILE WAS GENERATED AUTOMATICALLY. DO NOT MODIFY IT. YOUR CHANGES WILL
 * BE LOST. INSTEAD MODIFY CONCRETE IMPLEMENTATION OF THIS CLASS.
 * @category Carerix
 * @licence http://www.opensource.org/licenses/lgpl-license.php LGPL
 * @link http://www.carerix.com
 * @copyright Copyright 2011-2012 Carerix (http://www.carerix.com). All rights
 * reserved.
 * @author Andrey Yakubovskiy <andrey.yakubovskiy@gmail.com>
 * @version Thu, 06 Dec 2012 08:56:07 +0000
 */
abstract class Carerix_Api_Rest_Entity_Abstract_CRVacancyEducation extends Carerix_Api_Rest_Entity
{

    /**
     * @access private
     * @var integer
     * @value_class NSNumber
     * @allows_null 0
     * @value_type i
     * @value_type_human long integer (32 bits)
     */
    public $vacancyEducationID = null;

    /**
     * @access private
     * @var string
     * @value_class NSCalendarDate
     * @allows_null 1
     */
    public $creationDate = null;

    /**
     * @access private
     * @var string
     * @value_class NSString
     * @allows_null 1
     * @width 16
     * @isUnique 1
     */
    public $importID = null;

    /**
     * @access private
     * @var string
     * @value_class NSCalendarDate
     * @allows_null 1
     */
    public $modificationDate = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRVacancy
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRVacancy")
     * @mandatory 0
     * @destination_entity CRVacancy
     * @to_many 0
     * @name toVacancy
     */
    public $toVacancy = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRDataNode
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRDataNode")
     * @mandatory 0
     * @destination_entity CRDataNode
     * @to_many 0
     * @name toLevel1Education1
     * @qualifier ((typeID = 26) or (typeID = 0))
     * @default
     * @nodeType Opleiding0
     */
    public $toLevel1Education1 = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRDataNode
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRDataNode")
     * @mandatory 0
     * @destination_entity CRDataNode
     * @to_many 0
     * @name toLevel1Education2
     * @qualifier ((typeID = 27) or (typeID = 0))
     * @default
     * @nodeType Opleiding1
     */
    public $toLevel1Education2 = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRDataNode
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRDataNode")
     * @mandatory 0
     * @destination_entity CRDataNode
     * @to_many 0
     * @name toLevel1Education3
     * @qualifier ((typeID = 28) or (typeID = 0))
     * @default
     * @nodeType Opleiding2
     */
    public $toLevel1Education3 = null;

    public static function configure(Carerix_Api_Rest_EntityConfiguration $entityConfiguration)
    {
        parent::configure($entityConfiguration);
        $entityConfiguration->setIdentifierKey("vacancyEducationID");
        $entityConfiguration->setName("CRVacancyEducation");
    }

    /**
     * Set vacancyEducationID.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRVacancyEducation
     */
    public function setVacancyEducationID($value)
    {
        $this->vacancyEducationID = $value;
        return $this;
    }

    /**
     * Get vacancyEducationID.
     *
     * @return integer
     */
    public function getVacancyEducationID()
    {
        return $this->vacancyEducationID;
    }

    /**
     * Set creationDate.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRVacancyEducation
     */
    public function setCreationDate($value)
    {
        $this->creationDate = $value;
        return $this;
    }

    /**
     * Get creationDate.
     *
     * @return string
     */
    public function getCreationDate()
    {
        return $this->creationDate;
    }

    /**
     * Set importID.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRVacancyEducation
     */
    public function setImportID($value)
    {
        $this->importID = $value;
        return $this;
    }

    /**
     * Get importID.
     *
     * @return string
     */
    public function getImportID()
    {
        return $this->importID;
    }

    /**
     * Set modificationDate.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRVacancyEducation
     */
    public function setModificationDate($value)
    {
        $this->modificationDate = $value;
        return $this;
    }

    /**
     * Get modificationDate.
     *
     * @return string
     */
    public function getModificationDate()
    {
        return $this->modificationDate;
    }

    /**
     * Set toVacancy.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRVacancy $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRVacancyEducation
     */
    public function setToVacancy($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRVacancy($value); 
        }                 
        $this->toVacancy = $value;
        return $this;
    }

    /**
     * Get toVacancy.
     *
     * @return Carerix_Api_Rest_Entity_CRVacancy
     */
    public function getToVacancy()
    {
        return $this->toVacancy;
    }

    /**
     * Set toLevel1Education1.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRDataNode $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRVacancyEducation
     */
    public function setToLevel1Education1($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRDataNode($value); 
        }                 
        $this->toLevel1Education1 = $value;
        return $this;
    }

    /**
     * Get toLevel1Education1.
     *
     * @return Carerix_Api_Rest_Entity_CRDataNode
     */
    public function getToLevel1Education1()
    {
        return $this->toLevel1Education1;
    }

    /**
     * Set toLevel1Education2.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRDataNode $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRVacancyEducation
     */
    public function setToLevel1Education2($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRDataNode($value); 
        }                 
        $this->toLevel1Education2 = $value;
        return $this;
    }

    /**
     * Get toLevel1Education2.
     *
     * @return Carerix_Api_Rest_Entity_CRDataNode
     */
    public function getToLevel1Education2()
    {
        return $this->toLevel1Education2;
    }

    /**
     * Set toLevel1Education3.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRDataNode $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRVacancyEducation
     */
    public function setToLevel1Education3($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRDataNode($value); 
        }                 
        $this->toLevel1Education3 = $value;
        return $this;
    }

    /**
     * Get toLevel1Education3.
     *
     * @return Carerix_Api_Rest_Entity_CRDataNode
     */
    public function getToLevel1Education3()
    {
        return $this->toLevel1Education3;
    }


}